﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using EZ_B;

namespace Tutorial_31___AR_Drone {

  public partial class Form1 : Form {

    float moveSensitivivivity = 0.20f;
    int   moveSleepTime       = 400;

    public Form1() {

      InitializeComponent();
    }

    private void Form1_Load(object sender, EventArgs e) {

      ezB_Connect1.EZB.ShowDebugWindow();

      ezB_Connect1.EZB.ARDroneControl.OnImagecomplete += new EZ_B.ARDrone.DroneControl.OnImageCompleteHandler(ARDroneControl_OnImagecomplete);

      button2.Enabled = false;
    }

    private void button1_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.Connect();

      button1.Enabled = false;
      button2.Enabled = true;
    }

    void ARDroneControl_OnImagecomplete(Image image) {

      try {

        panel1.CreateGraphics().DrawImageUnscaled(image, 0, 0);
      } catch {
      }
    }

    private void button2_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.Disconnect();

      button1.Enabled = true;
      button2.Enabled = false;
    }

    private void button3_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.PlayLedAnimation(EZ_B.ARDrone.Commands.LedAnimationEnum.BlinkRed, 2, 10);
    }

    private void button4_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.TakeOff();
    }

    private void button5_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.Emergency();
    }

    private void button6_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.StartVideo();
    }

    private void button7_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.StopVideo();
    }

    private void button8_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SetFlatTrim();
    }

    private void button9_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button11_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SetProgressiveInputValues(0, -moveSensitivivivity, 0, 0);

      System.Threading.Thread.Sleep(moveSleepTime);

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button14_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SetProgressiveInputValues(0, moveSensitivivivity, 0, 0);

      System.Threading.Thread.Sleep(moveSleepTime);

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button13_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SetProgressiveInputValues(0, 0, 0, moveSensitivivivity);

      System.Threading.Thread.Sleep(moveSleepTime);

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button12_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SetProgressiveInputValues(0, 0, 0, -moveSensitivivivity);

      System.Threading.Thread.Sleep(moveSleepTime);

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button17_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button15_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SetProgressiveInputValues(0, 0, moveSensitivivivity, 0);

      System.Threading.Thread.Sleep(moveSleepTime);

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button16_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SetProgressiveInputValues(0, 0, -moveSensitivivivity, 0);

      System.Threading.Thread.Sleep(moveSleepTime);

      ezB_Connect1.EZB.ARDroneControl.Hover();
    }

    private void button18_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SwitchVideoChannel(EZ_B.ARDrone.Commands.VideoChannelEnum.Next);
    }

    private void button19_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.Land();
    }

    private void button20_Click(object sender, EventArgs e) {

      ezB_Connect1.EZB.ARDroneControl.SendDefaultValues();
    }

    private void button21_Click(object sender, EventArgs e) {

      if (MessageBox.Show("Are you sure? This will rename your Drone's Wifi to the specified name", string.Empty, MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.No)
        return;

      ezB_Connect1.EZB.ARDroneControl.SetWiFiNetworkName(textBox1.Text);

      MessageBox.Show("You have to reboot the device for changes");
    }

    private void button22_Click(object sender, EventArgs e) {

      tbLog.Text = ezB_Connect1.EZB.ARDroneControl.GetControlConfig();
    }
  }
}
